Index: cprs/trunk/CPRS-Chart/Orders/fODBBank.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 829)
@@ -422,4 +1462,5 @@
       LabSubscript := Piece(ExtractDefault(LoadData, 'Item ID'),U,2);
       TestReqComment := ExtractDefault(LoadData, 'ReqCom');
+      UniqueCollSamp := false;
       if Length(ExtractDefault(LoadData, 'Unique CollSamp')) > 0 then UniqueCollSamp := True;
       x := ExtractDefault(LoadData, 'Unique CollSamp');
@@ -431,4 +1472,20 @@
       ExtractItems(SpecimenList, LoadData, 'Specimens');
       if LRFSPEC <> '' then SpecimenList.Add(GetOneSpecimen(StrToInt(LRFSPEC)));
+      UrgencyList := TStringList.Create;
+      if Length(ExtractDefault(LoadData, 'Default Urgency')) > 0 then  { forced urgency }
+        begin
+          ForceUrgency := True;
+          UrgencyList.Add(ExtractDefault(LoadData, 'Default Urgency'));
+          Urgency := StrToInt(Piece(ExtractDefault(LoadData, 'Default Urgency'), '^', 1));
+          uDfltUrgency := Urgency;
+        end
+      else
+        begin                 { list of urgencies }
+          ExtractItems(UrgencyList, LoadData, 'Urgencies');
+          if StrToIntDef(LRFURG, 0) > 0 then
+            Urgency := StrToInt(LRFURG)
+          else
+            Urgency := uDfltUrgency;
+        end;
       Comment := TStringList.Create ;
       CurWardComment := TStringList.Create;
@@ -443,5 +1500,5 @@
           OneSamp := TStringList.Create;
           try
-            OneSamp.Assign(GetOneCollSamp(StrToInt(LRFSAMP)));
+            FastAssign(GetOneCollSamp(StrToInt(LRFSAMP)), OneSamp);
             FillCollSampList(OneSamp, CollSampList.Count);
           finally
@@ -471,4 +1528,5 @@
   CollSampList.Free;
   SpecimenList.Free;
+  UrgencyList.Free;
   CurWardComment.Free;
   Comment.Free;
@@ -631,5 +1689,5 @@
     begin
       if SpecimenList.Count = 0 then LoadSpecimens(SpecimenList) ;
-      AComboBox.Items.Assign(SpecimenList);
+      FastAssign(SpecimenList, AComboBox.Items);
       AComboBox.Items.Add('0^Other...');
       with QuickOrderResponses do tmpResp := FindResponseByName('SPECIMEN'  ,1);
@@ -659,4 +1717,25 @@
 end;
 
+procedure TLabTest.LoadUrgency(CollType: string; AComboBox:TORComboBox);
+var
+  i: integer;
+begin
+  if UrgencyList.Count < 1 then Exit;
+  with AComboBox do
+    begin
+      Clear;
+      for i := 0 to UrgencyList.Count - 1 do
+         if (CollType = 'LC') and (Piece(UrgencyList[i], U, 3) = '') then
+           Continue
+         else
+           Items.Add(UrgencyList[i]);
+      if (LRFURG <> '') and (ALabTest.ObtainUrgency) then
+        SelectByID(LRFURG)
+      else
+        SelectByIEN(uDfltUrgency);
+      Urgency := AComboBox.ItemIEN;
+    end;
+end;
+
 function TLabTest.NameOfCollSamp: string;
 var
@@ -683,4 +1762,17 @@
 end;
 
+function TLabTest.NameOfUrgency: string;
+var
+  i: Integer;
+begin
+  Result := '';
+  with UrgencyList do for i := 0 to Count - 1 do
+  begin
+    if StrToInt(Piece(Strings[i], '^', 1)) = Urgency
+      then Result := Piece(Strings[i], '^', 2);
+    break;
+  end;
+end;
+
 function TLabTest.ObtainCollSamp: Boolean;
 begin
@@ -698,4 +1790,9 @@
 end;
 
+function TLabTest.ObtainUrgency: Boolean;
+begin
+  Result := not ForceUrgency;
+end;
+
 function TLabTest.ObtainComment: Boolean;
 begin
@@ -708,4 +1805,9 @@
 end;
 
+procedure TfrmODBBank.ExtractReasons(OutList:TStrings; AList:TStrings);
+begin
+  ExtractItems(Outlist, AList,'REASONS');
+end;
+
 procedure TfrmODBBank.ExtractUrgencies(OutList:TStrings; AList:TStrings);
 begin
@@ -713,4 +1815,9 @@
 end;
 
+procedure TfrmODBBank.ExtractTNSOrders(OutList:TStrings; AList:TStrings);
+begin
+  ExtractItems(Outlist, AList,'TNS ORDERS');
+end;
+
 procedure TfrmODBBank.ExtractSurgeries(OutList:TStrings; AList:TStrings);
 begin
@@ -726,4 +1833,9 @@
 begin
   ExtractItems(OutList, AList, 'TYPE AND SCREEN');
+end;
+
+procedure TfrmODBBank.ExtractOther(OutList:TStrings; AList:TStrings);
+begin
+  ExtractItems(OutList, AList, 'OTHER');
 end;
 
@@ -813,7 +1925,14 @@
   inherited;
   if uSelectedItems.Count < 1 then
-    SetError(TX_NO_TESTS);
+    begin
+      SetError(TX_NO_TESTS);
+      Exit;
+    end;
   if uGetTns = 1 then
-    SetError(TX_TNS_REQUIRED);
+    begin
+      SetError(TX_TNS_REQUIRED);
+      Exit;
+    end;
+  ValidateAdd(AnErrMsg);
 end;
 
@@ -827,40 +1946,42 @@
 
 var
-  i, CmtType, DaysofFuturePast: integer;
+  aList: TStringList;
+  i, DaysofFuturePast: integer;
   d1, d2: TDateTime;
-  x: string;
+  x,test,aOther: string;
 const
   {Diagnostic Test Errors}
-  TX_NO_TIME        = 'Collection Time is required.' ;
-  TX_NO_TCOLLTYPE   = 'Collection Type is required.' ;
-  TX_NO_TESTS       = 'A Lab Test or tests must be selected.' ;
+  TX_NO_TIME        = 'Collection Time is required' ;
+  TX_NO_TCOLLTYPE   = 'Collection Type is required' ;
+  TX_NO_TESTS       = 'A Lab Test or tests must be selected' ;
   TX_BAD_TIME       = 'Collection times must be chosen from the drop down list or entered as valid' +
-                      ' Fileman date/times (T@1700, T+1@0800, etc.).' ;
-  TX_PAST_TIME      = 'Collection times in the past are not allowed.';
-  TX_NO_DAYS        = 'A number of days must be entered for continuous orders.';
-  TX_NO_TIMES       = 'A number of times must be entered for continuous orders.';
-  TX_NO_STOP_DATE   = 'Could not calculate the stop date for the order.  Check "for n Days".';
+                      ' Fileman date/times (T@1700, T+1@0800, etc.)' ;
+  TX_PAST_TIME      = 'Collection times in the past are not allowed';
+  TX_NO_DAYS        = 'A number of days must be entered for continuous orders';
+  TX_NO_TIMES       = 'A number of times must be entered for continuous orders';
+  TX_NO_STOP_DATE   = 'Could not calculate the stop date for the order.  Check "for n Days"';
   TX_TOO_MANY_DAYS  = 'Maximum number of days allowed is ';
   TX_TOO_MANY_TIMES = 'For this frequency, the maximum number of times allowed is:  X';
   //TX_NO_COMMENT     = 'A comment is required for this test and collection sample.';
-  TX_NUMERIC_REQD   = 'A numeric value is required for urine volume.';
-  TX_DOSEDRAW_REQD  = 'Both DOSE and DRAW times are required for this order.';
-  TX_TDM_REQD       = 'A value for LEVEL is required for this order.';
+  TX_NUMERIC_REQD   = 'A numeric value is required for urine volume';
+  TX_DOSEDRAW_REQD  = 'Both DOSE and DRAW times are required for this order';
+  TX_TDM_REQD       = 'A value for LEVEL is required for this order';
   //TX_ANTICOAG_REQD  = 'You must specify an anticoagulant on this order.' ;
-  TX_NO_COLLSAMPLE  = 'A collection sample MUST be specified.';
-  TX_NO_SPECIMEN    = 'A specimen MUST be specified.';
-  TX_NO_URGENCY     = 'An urgency MUST be specified.';
-  TX_NO_FREQUENCY   = 'A collection frequency MUST be specified.';
-  TX_NOT_LAB_COLL_TIME = ' is not a routine lab collection time.';
-  TX_NO_ALPHA       = 'For continuous orders, enter a number of days, or an "X" followed by a number of times.';
+  TX_NO_COLLSAMPLE  = 'A collection sample MUST be specified';
+  TX_NO_SPECIMEN    = 'A specimen MUST be specified';
+  TX_NO_URGENCY     = 'An urgency MUST be specified';
+  TX_NO_FREQUENCY   = 'A collection frequency MUST be specified';
+  TX_NOT_LAB_COLL_TIME = ' is not a routine lab collection time';
+  TX_NO_ALPHA       = 'For continuous orders, enter a number of days, or an "X" followed by a number of times';
   TX_BADTIME_CAP    = 'Invalid Immediate Collect Time';
   {Component/Type & Screen Errors}
-  TX_NO_COMPONENTS  = 'A Blood Product MUST be selected.';
-  TX_NO_QUANTITY    = 'The number of units MUST be specified under "Quantity".';
-  TX_HIGH_QUANTITY  = 'Quantity too high.';
+  TX_NO_COMPONENTS  = 'A Blood Product MUST be selected';
+  TX_NO_QUANTITY    = 'The number of units MUST be specified under "Quantity"';
+  TX_HIGH_QUANTITY  = 'Quantity too high';
   TX_NO_DATEMODIFIED= 'A Date/time Wanted MUST be specified';
-  //TX_NO_PREPARATION = 'Preparation MUST be specified - either "Hold" or "Immediate".';
   TX_NO_SURGERY     = 'A Surgery MUST be specified for Pre-Op orders';         //only if Pre-op selected
   TX_NO_REASON      = 'A Reason for Request MUST be entered';
+  TX_REASON_TOO_LONG= 'Reason for Request MUST be less than 76 characters long';
+  TX_MODIFIER_TOO_LONG = 'Modifer text MUST be less than 51 characters long';
   TX_NO_COMMENT     = 'A Comment MUST be entered for this Component';
   TX_DUPLICATE      = 'Duplicate Test/Component not allowed';
@@ -870,131 +1991,115 @@
   inherited;
   AnErrMsg := '';
-  if aLabTest = nil then
-    begin
-      AnErrMsg := TX_NO_TEST_SELECTED;
-      Exit;
-    end;
-  for i := 0 to uSelectedItems.Count - 1 do
-    if IntToStr(aLabTest.TestID) = piece(uSelectedItems[i],'^',2) then
+  aList := TStringList.Create;
+  try
+    ExtractOther(aList, uVBECList);
+    if aList.Count > 0 then aOther := aList[0];
+    aList.Clear;
+    if uSelectedItems.Count < 1 then
       begin
-        AnErrMsg := TX_DUPLICATE;
+        AnErrMsg := TX_NO_TEST_SELECTED;
         Exit;
       end;
-  if LRORDERMODE = TORDER_MODE_DIAG then
-    begin
-      with cboAvailTest do if ItemIEN <= 0 then SetError(TX_NO_TESTS);
-
-      if ALabTest <> nil then
-        if (cboCollType.ItemID = 'I') and (not ALabTest.LabCanCollect) then
+    for i := 0 to uSelectedItems.Count - 1 do
+      begin
+        x := uSelectedItems[i];
+        test := lvSelectionList.Items[i].Caption;
+        if piece(x,'^',1) = '1' then    //Diagnostic Test
           begin
-            SetError(TX_NO_IMMED);
-            cboCollType.ItemIndex := -1;
+            if uSpecimen = 0 then
+              if cboCollType.ItemID = '' then
+                SetError(TX_NO_TCOLLTYPE + ' (' + test + ')')
+              else if cboCollType.ItemID = 'LC' then
+                begin
+                 if Length(cboCollTime.Text) = 0 then SetError(TX_NO_TIME + ' (' + test + ')');
+                 with cboCollTime do if (Length(Text) > 0) and (ItemIndex = -1) then
+                   begin
+                     if StrToFMDateTime(Text) < 0 then
+                       SetError(TX_BAD_TIME + ' (' + test + ')')
+                     else if StrToFMDateTime(Text) < FMNow then
+                       SetError(TX_PAST_TIME + ' (' + test + ')')
+                     else if OrderForInpatient then
+                       begin
+                         d1 := FMDateTimeToDateTime(Trunc(StrToFMDateTime(cboColltime.Text)));
+                         d2 := FMDateTimeToDateTime(FMToday);
+                         if EvtDelayLoc > 0 then
+                           DaysofFuturePast := LabCollectFutureDays(EvtDelayLoc,EvtDivision)
+                         else
+                           DaysofFuturePast := LabCollectFutureDays(Encounter.Location);
+                         if DaysofFuturePast = 0 then DaysofFuturePast := 7;
+                         if ((d1 - d2) > DaysofFuturePast) then
+                           SetError('A lab collection cannot be ordered more than '
+                             + IntToStr(DaysofFuturePast) + ' days in advance');
+                       end
+                     else if EvtDelayLoc > 0 then
+                       begin
+                         if (not IsLabCollectTime(StrToFMDateTime(cboCollTime.Text), EvtDelayLoc)) then
+                           SetError(cboCollTime.Text + TX_NOT_LAB_COLL_TIME + ' (' + test + ')');
+                       end
+                     else if EvtDelayLoc <= 0 then
+                       begin
+                         if (not IsLabCollectTime(StrToFMDateTime(cboCollTime.Text), Encounter.Location)) then
+                           SetError(cboCollTime.Text + TX_NOT_LAB_COLL_TIME + ' (' + test + ')');
+                       end;
+                   end;
+                end
+              else
+                begin
+                  if cboCollType.ItemID = 'I' then
+                    begin
+                      calCollTime.Text := txtImmedColl.Text;
+                      x := ValidImmCollTime(calCollTime.FMDateTime);
+                      if (Piece(x, U, 1) <> '1') then
+                        SetError(Piece(x, U, 2));
+                    end;
+
+                  with calColltime do
+                    begin
+                      if FMDateTime = 0 then SetError(TX_BAD_TIME + ' (' + test + ')')
+                      else
+                        begin
+                          // date only was entered
+                          if (FMDateTime - Trunc(FMDateTime) = 0) then
+                            begin
+                              if (Trunc(FMDateTime) < FMToday) then SetError(TX_PAST_TIME + ' (' + test + ')');
+                            end
+                          // date/time was entered
+                          else
+                            begin
+                              if (UpperCase(Text) <> 'NOW') and (FMDateTime < FMNow) then SetError(TX_PAST_TIME + ' (' + test + ')');
+                            end;
+                        end;
+                    end;
+                end;
+
+            with cboUrgency do if ItemIEN  <= 0 then SetError(TX_NO_URGENCY + ' (' + test + ')');
+          end
+        else                            //Component
+          begin
+            if piece(x,'^',3) ='' then SetError(TX_NO_QUANTITY + ' (' + test + ')')
+              else
+                begin
+                  if StrToInt(piece(x,'^',3)) < 1 then SetError(TX_NO_QUANTITY + ' (' + test + ')');
+                  if StrToInt(piece(x,'^',3)) > 100 then SetError(TX_HIGH_QUANTITY + ' (' + test + ')');
+                end;
+            if calWantTime.Text = '' then SetError(TX_NO_DATEMODIFIED + ' (' + test + ')');
+            if (cboReasons.Text = '') and not(uReason = '') then
+              begin
+                SetError(TX_NO_REASON + ' (' + test + ').' + ' Previously entered ''Reason for Request'' will be retained.');
+                cboReasons.Text := uReason; //reset reason back to previous value
+              end;
+              if (cboReasons.Text = '') then
+                begin
+                  SetError(TX_NO_REASON + ' (' + test + ').');
+                end;
+            if (memDiagComment.Text = '') and (piece(x,'^',2) = aOther) then SetError(TX_NO_COMMENT + ' (' + test + ')');
+            if (cboUrgency.Text = 'PRE-OP') and (length(cboSurgery.Text) < 1) then SetError(TX_NO_SURGERY + ' (' + test + ')');
+            if (length(cboReasons.Text) > 75) then SetError(TX_REASON_TOO_LONG);
+            if (length(cboModifiers.Text) > 50) then SetError(TX_MODIFIER_TOO_LONG);
           end;
-      if uSpecimen = 0 then
-        if cboCollType.ItemID = '' then
-          SetError(TX_NO_TCOLLTYPE)
-        else if cboCollType.ItemID = 'LC' then
-          begin
-           if Length(cboCollTime.Text) = 0 then SetError(TX_NO_TIME);
-           with cboCollTime do if (Length(Text) > 0) and (ItemIndex = -1) then
-             begin
-               if StrToFMDateTime(Text) < 0 then
-                 SetError(TX_BAD_TIME)
-               else if StrToFMDateTime(Text) < FMNow then
-                 SetError(TX_PAST_TIME)
-               else if OrderForInpatient then
-                 begin
-                   d1 := FMDateTimeToDateTime(Trunc(StrToFMDateTime(cboColltime.Text)));
-                   d2 := FMDateTimeToDateTime(FMToday);
-                   if EvtDelayLoc > 0 then
-                     DaysofFuturePast := LabCollectFutureDays(EvtDelayLoc,EvtDivision)
-                   else
-                     DaysofFuturePast := LabCollectFutureDays(Encounter.Location);
-                   if DaysofFuturePast = 0 then DaysofFuturePast := 7;
-                   if ((d1 - d2) > DaysofFuturePast) then
-                     SetError('A lab collection cannot be ordered more than '
-                       + IntToStr(DaysofFuturePast) + ' days in advance');
-                 end
-               else if EvtDelayLoc > 0 then
-                 begin
-                   if (not IsLabCollectTime(StrToFMDateTime(cboCollTime.Text), EvtDelayLoc)) then
-                     SetError(cboCollTime.Text + TX_NOT_LAB_COLL_TIME);
-                 end
-               else if EvtDelayLoc <= 0 then
-                 begin
-                   if (not IsLabCollectTime(StrToFMDateTime(cboCollTime.Text), Encounter.Location)) then
-                     SetError(cboCollTime.Text + TX_NOT_LAB_COLL_TIME);
-                 end;
-             end;
-          end
-        else
-          begin
-            if cboCollType.ItemID = 'I' then
-              begin
-                calCollTime.Text := txtImmedColl.Text;
-                x := ValidImmCollTime(calCollTime.FMDateTime);
-                if (Piece(x, U, 1) <> '1') then
-                  SetError(Piece(x, U, 2));
-              end;
-
-            with calColltime do
-              begin
-                if FMDateTime = 0 then SetError(TX_BAD_TIME)
-                else
-                  begin
-                    // date only was entered
-                    if (FMDateTime - Trunc(FMDateTime) = 0) then
-                      begin
-                        if (Trunc(FMDateTime) < FMToday) then SetError(TX_PAST_TIME);
-                      end
-                    // date/time was entered
-                    else
-                      begin
-                        if (UpperCase(Text) <> 'NOW') and (FMDateTime < FMNow) then SetError(TX_PAST_TIME);
-                      end;
-                  end;
-              end;
-          end;
-
-      with cboUrgency do if ItemIEN  <= 0 then SetError(TX_NO_URGENCY);
-      if ALabTest <> nil then
-        begin
-          CmtType := FCmtTypes.IndexOf(ALabTest.CurReqComment) ;
-          with ALabTest do
-          case CmtType of
-            0 : {ANTICOAGULATION}         {if (Pos('ANTICOAGULANT',Comment.Text)=0) then
-                                         SetError(TX_ANTICOAG_REQD)};
-            1 : {DOSE/DRAW TIMES}         if (Pos('Last dose:',Comment.Text)=0) or
-                                          (Pos('draw time:',Comment.Text)=0) then
-                                         SetError(TX_DOSEDRAW_REQD);
-            2 : {ORDER COMMENT}           {if (Length(Comment.Text)=0) then
-                                         SetError(TX_NO_COMMENT)};
-            3 : {ORDER COMMENT MODIFIED}  {if (Length(Comment.Text)=0) then
-                                         SetError(TX_NO_COMMENT)};
-            4 : {TDM (PEAK-TROUGH}        if (Pos('Dose is expected',Comment.Text)=0) then
-                                         SetError(TX_TDM_REQD);
-            5 : {TRANSFUSION}             {if (Length(Comment.Text)=0) then
-                                         SetError(TX_NO_COMMENT)};
-            6 : {URINE VOLUME}            if (Length(Comment.Text)>0) and
-                                       (ExtractInteger(Comment.Text)<=0) then
-                                          Comment.Text := '?';
-                                         {SetError(TX_NUMERIC_REQD);}
-          end;
-        end;
-    end
-  else if LRORDERMODE = TORDER_MODE_COMP then
-    begin
-      with cboAvailComp do
-        begin
-          if ItemIEN <= 0 then SetError(TX_NO_COMPONENTS);
-        end;
-      if StrToInt(tQuantity.Text) < 1 then SetError(TX_NO_QUANTITY);
-      if calWantTime.Text = '' then SetError(TX_NO_DATEMODIFIED);
-      //if cboPreparation.Text ='' then SetError(TX_NO_PREPARATION);
-      if StrToInt(tQuantity.Text) > 100 then SetError(TX_HIGH_QUANTITY);
-      if tReason.Text = '' then SetError(TX_NO_REASON);
-      if (txtDiagComment.Text = '') and (cboAvailComp.Text = 'OTHER') then SetError(TX_NO_COMMENT);
-      if (cboUrgency.Text = 'PRE-OP') and (length(cboSurgery.ItemID) < 1) then SetError(TX_NO_SURGERY);
-    end;
+      end;
+  finally
+    aList.Free;
+  end;
 end;
 
